// fichier : event.cc
// version : 1.0
// 
#include <iostream>
#include <limits>
#include <vector>

using namespace std;
#include "event.h"


static    vector<Event> tab; // vide à l'initialisation

// le test d'égalité de deux instances est possible grâce
// à la surcharge de l'opérateur == 
bool    Event::event_add_to_database()
{	
	for(size_t i(0) ; i < tab.size() ; ++i)
	{
		if(tab[i] == *this )
		{
			cout << "Erreur: Event déjà présent dans agenda !" << endl ; 
			return false;
		}
		
		if(tab[i].lieu == this->lieu)
		{
			if(tab[i].date.nb_of_days_between_dates(this->date) < 7)
			{
				cout << "Cet autre Event est trop proche (moins d'une semaine)!" ;
				cout << endl ; 
				tab[i].affiche();
				cout << endl;
				return false;	
			}
		}
	}	
	tab.push_back(*this);
	return true;	
}

bool Event::operator==(const Event& b)
{
	return( nom  == b.nom  &&
			lieu == b.lieu &&
			date == b.date);
}

bool Event::operator!=(const Event& b)
{
	return( not ((*this)==b));
}

void	 Event::affiche() const
{
	cout << endl << "Nom   : " << nom  << endl
				 << "Lieu  : " << lieu << endl
				 << "Date  : " ;
				 
	date.affiche() ;
}


// the special character '\t' is a tabulation
void	 event_display_all()
{
	for( const Event& e: tab) e.affiche();
}
