// fichier : test.cc associé aux modules event et date
// version : 1.0
// 
#include <cstdlib>
#include <iostream>
#include <limits>

using namespace std;
#include "event.h"
#include "date.h"

int main(void)
{	
	cout << "\nStart of program" << endl;
	int nb_event=0;
	
	bool echec(false);
	do
	{
        echec = false;
	    cout << "\n nombre d'events: ";
	    if(not(cin >> nb_event))
        {
			echec = true;
            cin.clear();
            cin.ignore(numeric_limits<streamsize>::max(),'\n');
        }
	}while(echec || nb_event <= 0);
	
    int i(0);
    while(i< nb_event)
    {
		unsigned day, month, year;
		cout << endl << "Date : ";
		cin >> day >> month >> year ;
		Date date(day,month,year);
		
		string nom, lieu;
		cout << "Nom : ";
		cin  >> nom ;
		cout << "Lieu: ";
		cin  >> lieu ;
		
		Event temp(nom,lieu,date);
		
		if(temp.event_add_to_database()) ++i;
	}

	cout << "\nEvent database content\n" << endl;
	event_display_all();

	cout << "\nEnd of program" << endl;		
	return EXIT_SUCCESS;
}
